//
//  TOPPERS/JSP Kernel
//      Toyohashi Open Platform for Embedded Real-Time Systems/
//      Just Standard Profile Kernel
// 
//  Copyright (C) 2000-2004 by Embedded and Real-Time Systems Laboratory
//                              Toyohashi Univ. of Technology, JAPAN
//  Copyright (C) 2001-2004 by Dep. of Computer Science and Engineering
//                   Tomakomai National College of Technology, JAPAN
//
//  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
//  ˤäƸɽƤ GNU General Public License  Version 2 ˵
//  ҤƤ˸¤ꡤܥեȥܥեȥ
//  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
//  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
//  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
//      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
//      ˴ޤޤƤ뤳ȡ
//  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
//      ѤǤǺۤˤϡۤȼɥȡ
//      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
//      ̵ݾڵǺܤ뤳ȡ
//  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
//      ѤǤʤǺۤˤϡΤ줫ξ
//      ȡ
//    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
//        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
//    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
//        𤹤뤳ȡ
//  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
//      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
//
//  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
//  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
//  ޤơʤݾڤԤʤޤܥեȥѤˤľ
//  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
// 
//  @(#) $Id: tinet_parser.cpp,v 1.2 2004/09/07 00:49:09 abe Exp abe $
//

#include <stdarg.h>

#include "base/parser.h"
#include "base/mpstrstream.h"

#include "tinet_defs.h"
#include "tinet_classes.h"

#include <sstream>
#include <set>
#include <map>
#include <iomanip>

// ֤̾λ

using namespace std;

//
// CoreParser -- ʸϤΥ󥹥ȥ饯
//

CoreParser::CoreParser (void)
{
	setBanner("--- TCP/IP Protocol Stack Configurator ver 1.1 (for JSP rel 1.4) ---");
	}

//
// CoreParser::parseOption -- ʸϤΥץ
//

void
CoreParser::parseOption (Directory& container)
{
	ParserComponent::parseOption(container);	// ƥ饹Υץβ

	if (findOption("h", "help")) {
		cerr << Message (
			"  -obj, --dump-object=filename : Dump the object tree into file specified\n"
			"  -ao, --assign-order=order    : Specify the order of automatic ID assignment\n"
			"    You can use three terms below as ordering rule.\n"
			"      alphabetic (in alphabetic order)\n"
			"      fcfs       (in arrival order [as default])\n"
			"      reverse    (reverse the order)\n",

			"  -obj, --dump-object=ե̾ : ꤷե˥֥ȾϤޤ\n"
			"  -ao, --assign-order=       : ư ID γꤷޤ\n"
			"    aphabetic (ABC ), fcfs ( [ǥե]), reverse (ս)\n"
			);
		}
	}

//
// CoreParser::assignID -- ʸϤΥ֥ ID γ
//

enum tagAssignmentOrder {
	UNKNOWN,
	ALPHABETIC,
	FCFS,
	REVERSE = 0x80,
	REVERSE_ALPHABETIC,
	REVERSE_FCFS,
	};

int
CoreParser::assignID (Directory& container, const char *category)
{
	set<int>		idpool;
	map<int, Directory *>	sorter;
	map<int, Directory *>::iterator	entry;
	Directory		*node = NULL;
	Directory		*scope;
	Directory		*work;
	tagAssignmentOrder	order;
	int			id;

	// Ȥꤢ
	order = FCFS;

	// ꤵ줿Ū API ʤнλ
	node = container.findChild(OBJECT_TREE, category, NULL);
	if (node == NULL)
		return 0;

	// ƽꤹ롣
	for (id = 1; id < (signed int)node->size() + 32; id ++)
		idpool.insert(id);

	// ƸꤷƺѤ ID 롣
	id = 0;
	scope = node->getFirstChild();
	while (scope != NULL) {

		// ID ꤵƤȤ
		if (*scope == Directory::INTEGER)
			idpool.erase(*scope);
		else {
			// ID νʣå롣
			work = container.openChild("/", "identifier", scope->getKey().c_str(), NULL);
			if (*work == Directory::INTEGER)  {
				VerboseMessage("Assigning the same ID (%) since the name (%[%]) is duplicated\n",
				               "ID ֹ (%) ۼƱ̾Υ֥ (%[%]) ˳Ƥޤ\n")
				               << work->toInteger() << scope->getKey().c_str() <<category;
				idpool.erase(*scope = work->toInteger());
				}
			else {
				// ƽ˽äơƸɲä롣
				switch (order) {
				case ALPHABETIC:
					sorter[id ++] = scope;
					break;
				case REVERSE_ALPHABETIC:
					sorter[id --] = scope;
					break;
				case REVERSE_FCFS:
					sorter[- scope->openChild("#order")->toInteger()] = scope;
					break;
				case FCFS:
				default:
					sorter[scope->openChild("#order")->toInteger()] = scope;
					break;
					}
				}
			}
		scope = scope->getNext();
		}

	// ID Ƥ롣
	entry = sorter.begin();
	while (entry != sorter.end()) {
		scope = (*entry).second;
		if (*scope != Directory::INTEGER) {
			id = *(idpool.begin());
			idpool.erase(idpool.begin());
			work = container.openChild("/","identifier", scope->getKey().c_str(), NULL);
			*work  = id;
			*scope = id;
			}
		entry ++;
		}

	// ɽ
	if (node->size() != 0 && VerboseMessage::getVerbose()) {
		VerboseMessage("Object ID assignment list [%s]\n",
		               "֥ ID ɽ [%]\n") << category;

		sorter.clear();
		scope = node->getFirstChild();
		while (scope != NULL) {
			sorter[scope->toInteger()] = scope;
			scope = scope->getNext();
			}

		entry = sorter.begin();
		while (entry != sorter.end()) {
			VerboseMessage("  % : %\n") << setw(3) << (*entry).first << (*entry).second->getKey().c_str();
			entry ++;
			}
		}

	// Ϣ³ ID θ
	if ((signed)node->size() + 1 != *(idpool.begin()))
		ExceptionMessage("Discontinuous %s ID assignment occured",
		                 "Ϣ³ʥ֥ ID (%)") << category << throwException;

	return node->size();
	}

//
// CoreParser::parse -- ʸ
//

bool
CoreParser::parse (Parser& parser, Directory& container)
{
	Token	token;
	bool	errorOccured;

	try {
		errorOccured = false;

		// Ū API ιʸ
		do {
			parser.getToken(token);
			if (token == Token::IDENTIFIER) {
				try {
					this->parseStaticAPI(parser, container, token);
					}
				catch (...) {
					errorOccured = true;
					}
				}
			} while (token != Token::EOS);

		if (errorOccured)
			ExceptionMessage(ExceptionMessage::FATAL,
			                "The configuration process was aborted due to occurence of parse error",
			                "ʸϤ˼ԤǤޤ").throwException();

		// ֥ ID Ƥ롣
		assignID(container, TCP_CREATE_REP);
		assignID(container, TCP_CREATE_CEP);
		assignID(container, UDP_CREATE_CEP);
		assignID(container, TCP6_CREATE_REP);
		assignID(container, TCP6_CREATE_CEP);
		assignID(container, UDP6_CREATE_CEP);

		return true;
		}

	catch (Exception& e) {
		throw e;
		}
	}

//
// SpecialtyFile::SpecialtyFile -- constructor
//

SpecialtyFile::SpecialtyFile (void) throw() : MultipartStream(), RuntimeObject(true)
{
	}

//
// getFileName -- ե̾
//

string getFileName (string category, string def_cat) throw(Exception)
{
	string result(def_cat);
	OptionParameter::OptionItem item = getOptionParameter()[category];

	if (item.isValid()) {
		if (item.countParameter() == 1)
			result = item[0];
		else
			ExceptionMessage("-% should have just ONE filename.",
			                 "-%ץ˻Ǥե 1 ĤΤ")
				<< category << throwException;
		}

	if (result.empty())
		ExceptionMessage("-% has illegal filename.",
		                 "-%ץϤ줿ե̾")
			<< category << throwException;

	return result;
	}

//
// createTinetCfg -- tinet_cfg.c ե
//

TinetCfg*
createTinetCfg (void)
{
	TinetCfg*		cfg = NULL;
	TinetCfg::CreationEvent	event;

	cfg = TinetCfg::createInstance(getFileName("tinet_cfg", "tinet_cfg.c"));
	cfg->disableOutput();

	// ֥ȤγǼ
	cfg->createPart("header")
	    .createPart("include")
	    .createPart("define")
	    .createPart(TCP_CREATE_REP)
	    .createPart(TCP_CREATE_CEP)
	    .createPart(UDP_CREATE_CEP)
	    .createPart(TCP6_CREATE_REP)
	    .createPart(TCP6_CREATE_CEP)
	    .createPart(UDP6_CREATE_CEP);

	// ե٥Ȥμ¹
	event.file = cfg;
	Event<TinetCfg::CreationEvent>::raise(event);


	// 顼Υå
	if (event.file == 0)
		ExceptionMessage("Internal error: tinet_cfg event handler eliminates the instance.",
		                 "顼: tinet_cfg Υϥɥ餬󥹥󥹤") << throwException;

	if (RuntimeObjectTable::getInstance(typeid(TinetCfg)) != event.file)
		ExceptionMessage("Internal error: tinet_cfg event handler create the illegal instance.",
		                 "顼: tinet_cfg Υϥɥ餬ʥ󥹥󥹤") << throwException;

	// __EMPTY_LABEL ޥν
	cfg->movePart("define");
	if (!getOptionParameter()["z"].isValid()) {
		(*cfg) <<	"#ifndef __EMPTY_LABEL\n"
				"#define __EMPTY_LABEL(x,y)\tx y[1]\n"
				"#endif\t/* of #ifndef __EMPTY_LABEL */\n\n";
		}

	return event.file;
	}

//
// createTinetKern -- tinet_kern.cfg ե
//

TinetKernCfg*
createTinetKernCfg (void)
{
	TinetKernCfg*			kern = NULL;
	TinetKernCfg::CreationEvent	event;

	kern = TinetKernCfg::createInstance(getFileName("tinet_kern_cfg", "tinet_kern.cfg"));
	kern->disableOutput();

	// ֥ȤγǼ
	kern->createPart("header")
	     .createPart(TCP_CREATE_REP)
	     .createPart(TCP_CREATE_CEP)
	     .createPart(UDP_CREATE_CEP)
	     .createPart(TCP6_CREATE_REP)
	     .createPart(TCP6_CREATE_CEP)
	     .createPart(UDP6_CREATE_CEP);

	// ե٥Ȥμ¹
	event.file = kern;
	Event<TinetKernCfg::CreationEvent>::raise(event);

	// 顼Υå
	if (event.file == 0)
		ExceptionMessage("Internal error: tinet_cfg event handler eliminates the instance.",
		                 "顼: tinet_cfg Υϥɥ餬󥹥󥹤") << throwException;

	if (RuntimeObjectTable::getInstance(typeid(TinetKernCfg)) != event.file)
		ExceptionMessage("Internal error: tinet_cfg event handler create the illegal instance.",
		                 "顼: tinet_cfg Υϥɥ餬ʥ󥹥󥹤") << throwException;

	return event.file;
	}

//
// createTinetID -- tinet_id.h ե
//

TinetID*
createTinetID (void)
{
	TinetID*		id = NULL;
	TinetID::CreationEvent	event;

	id = TinetID::createInstance(getFileName("tinet_id", "tinet_id.h"));
	id->disableOutput();

	// ֥ȤγǼ
	id->createPart("header")
	   .createPart("body")
	   .createPart("footer");

	// ե٥Ȥμ¹
	event.file = id;
	Event<TinetID::CreationEvent>::raise(event);

	// 顼Υå
	if (event.file == 0)
		ExceptionMessage("Internal error: tinet_cfg event handler eliminates the instance.",
		                 "顼: tinet_cfg Υϥɥ餬󥹥󥹤") << throwException;

	if (RuntimeObjectTable::getInstance(typeid(TinetID)) != event.file)
		ExceptionMessage("Internal error: tinet_cfg event handler create the illegal instance.",
		                 "顼: tinet_cfg Υϥɥ餬ʥ󥹥󥹤") << throwException;

	// ¿ť󥯥롼ɲ
	id->movePart("header");
	(*id) << "#ifndef _TINET_ID_H_\n#define _TINET_ID_H_\n\n";

	id->movePart("footer");
	(*id) << "\n#endif\t/* of _TINET_ID_H_*/\n";

	return event.file;
	}

//
// ConfigurationFileGenerator::parseOption -- եΥץ
//

void
ConfigurationFileGenerator::parseOption (Directory& parameter)
{
	string		name;

	if (findOption("h", "help")) {
		cerr << endl << Message (
			"TINET configuration file generator\n"
			"  -id,  --tinet_id      =filename : Specify the name of ID assignment file\n"
			"  -cfg, --tinet_cfg     =filename : Specify the name of TINET configuration file\n"
			"  -kern,--tinet_kern_cfg=filename : Specify the name of TINET kernel configuration file\n"
			"  -z,   --nonzero                 : Do not output __EMPTY_LABEL macro and related definitions\n",

			"TINET ե\n"
			"  -id,  --tinet_id      =ե̾ : ID ե̾ꤷޤ\n"
			"  -cfg, --tinet_cfg     =ե̾ : TINET ե̾ꤷޤ\n"
			"  -kern,--tinet_kern_cfg=ե̾ : TINET ͥ빽ե̾ꤷޤ\n"
			"  -z,   --nonzero                   : __EMPTY_LABEL ޥλѤ¤ޤ\n");
		return;
		}

	// ID ե (tinet_id.h) ν

	createTinetID();

	// TINET ե (tinet_cfg.c) ν

	createTinetCfg();

	// TINET ͥ빽ե (tinet_kern.cfg) ν
	//
	//   ո̿üǻѤ륫ͥ륪֥ȤϤ롣
	//

	createTinetKernCfg();

	activateComponent();
	}

//
// ConfigurationFileGenerator::onFatalExit -- ۾ｪλν
//

void
ConfigurationFileGenerator::onFatalExit (Directory& container)
{
	// 㳰ˤ۾ｪλȤνեʤ
	dynamic_cast<MultipartStream *>(RuntimeObjectTable::getInstance(typeid(TinetCfg)))->disableOutput();
	dynamic_cast<MultipartStream *>(RuntimeObjectTable::getInstance(typeid(TinetID)))->disableOutput();
	dynamic_cast<MultipartStream *>(RuntimeObjectTable::getInstance(typeid(TinetKernCfg)))->disableOutput();
	}

//
// ConfigurationFileGenerator::outTinet_id_h -- ID ե (tinet_id.h) Ϥ롣
//

void
ConfigurationFileGenerator::outTinet_id_h (Directory& container)
{
	TinetID*	out;
	Directory*	scope;

	out = dynamic_cast<TinetID *>(RuntimeObjectTable::getInstance(typeid(TinetID)));
	if (out == 0) {
		ExceptionMessage("Internal error: The stream buffer of tinet_id.h disappeared.",
		                 "顼: tinet_id.h ѤΥե륹ȥ꡼बޤ") << throwException;
		return;
		}

	out->movePart("body");
	scope = Singleton<Directory>::getInstance()->findChild("/identifier")->getFirstChild();
	while (scope != NULL) {
		(*out) << "#define "
		       << scope->getKey() << "\t" << scope->toInteger() << "\n";
		scope = scope->getNext();
		}

	out->enableOutput();
	}

//
// ConfigurationFileGenerator::outCfgTCP_CRE_REP --  TCP ոϤ롣
//

void
ConfigurationFileGenerator::outCfgTCP_CRE_REP (MultipartStream* out, Directory& container)
{
	if (container.size() > 0) {
		Directory*	scope;
		int		count;
		map<int, Directory*>		sorter;
		map<int, Directory*>::iterator	psorter;

		out->movePart(TCP_CREATE_REP);

		// TCP ոϤ롣
		(*out) << "#define TNUM_TCP_CREPID\t" << container.size() << "\n\n";

		// TCP ոκ ID Ϥ롣
		(*out) << "const ID tmax_tcp_crepid = (TMIN_TCP_CREPID + TNUM_TCP_CREPID - 1);\n\n";

		// ID ˥Ȥ롣
		count = 0;
		scope = container.getFirstChild();
		while (scope != NULL) {
			sorter[scope->toInteger(count ++)] = scope;
			scope = scope->getNext();
			}

		//  TCP ոϤ롣
		(*out) << "T_TCP_CREP tcp_crep[TNUM_TCP_CREPID] = {\n";
		count = 1;
		psorter = sorter.begin();
		while (psorter != sorter.end()) {
			(*out) << "\t{\n";

			// ITRON TCP/IP API ɸ
			(*out) << "\t\t"   << (*(*psorter).second)["repatr"].toString() << ",\n";
			(*out) << "\t\t{ " << (*(*psorter).second)["myipaddr"].toString() << ", "
			                   << (*(*psorter).second)["myportno"].toString() << " },\n";

			(*out) << "\t\t},\n";
			psorter ++;
			}
		(*out) << "\t};\n\n";
		}
	}

//
// ConfigurationFileGenerator::outCfgTCP_CRE_CEP --  TCP ̿üϤ롣
//

void
ConfigurationFileGenerator::outCfgTCP_CRE_CEP (MultipartStream* out, Directory& container)
{
	if (container.size() > 0) {
		Directory*	scope;
		int		count;
		map<int, Directory*>		sorter;
		map<int, Directory*>::iterator	psorter;

		out->movePart(TCP_CREATE_CEP);

		// TCP ̿üϤ롣
		(*out) << "#define TNUM_TCP_CCEPID\t" << container.size() << "\n\n";

		// TCP ̿üκ ID Ϥ롣
		(*out) << "const ID tmax_tcp_ccepid = (TMIN_TCP_CCEPID + TNUM_TCP_CCEPID - 1);\n\n";

		// ID ˥Ȥ롣
		count = 0;
		scope = container.getFirstChild();
		while (scope != NULL) {
			sorter[scope->toInteger(count ++)] = scope;
			scope = scope->getNext();
			}

		//  TCP ̿üϤ롣
		(*out) << "T_TCP_CCEP tcp_ccep[TNUM_TCP_CCEPID] = {\n";
		count = 1;
		psorter = sorter.begin();
		while (psorter != sorter.end()) {
			(*out) << "\t{\n";

			// ITRON TCP/IP API ɸ
			(*out) << "\t\t" << (*(*psorter).second)["cepatr"  ].toString() << ",\n";
			(*out) << "\t\t" << (*(*psorter).second)["sbuf"    ].toString() << ",\n";
			(*out) << "\t\t" << (*(*psorter).second)["sbufsz"  ].toString() << ",\n";
			(*out) << "\t\t" << (*(*psorter).second)["rbuf"    ].toString() << ",\n";
			(*out) << "\t\t" << (*(*psorter).second)["rbufsz"  ].toString() << ",\n";
			(*out) << "\t\t" << (*(*psorter).second)["callback"].toString() << ",\n";

			// ¸
			(*out) << "\t\tSEM_TCP_CEP_LOCK"       << count    << ",\n";
			(*out) << "\t\tSEM_TCP_CEP_SBUF_BUSY"  << count    << ",\n";
			(*out) << "\t\tSEM_TCP_CEP_RBUF_READY" << count    << ",\n";
			(*out) << "\t\tFLG_TCP_CEP"            << count ++ << ",\n";

			(*out) << "\t\t},\n";
			psorter ++;
			}
		(*out) << "\t};\n\n";
		}
	}

//
// ConfigurationFileGenerator::outCfgUDP_CRE_CEP --  UDP ̿üϤ롣
//

void
ConfigurationFileGenerator::outCfgUDP_CRE_CEP (MultipartStream* out, Directory& container)
{
	if (container.size() > 0) {
		Directory*	scope;
		int		count;
		map<int, Directory*>		sorter;
		map<int, Directory*>::iterator	psorter;

		out->movePart(UDP_CREATE_CEP);

		// UDP ̿üϤ롣
		(*out) << "#define TNUM_UDP_CCEPID\t" << container.size() << "\n\n";

		// UDP ̿üκ ID Ϥ롣
		(*out) << "const ID tmax_udp_ccepid = (TMIN_UDP_CCEPID + TNUM_UDP_CCEPID - 1);\n\n";

		// ID ˥Ȥ롣
		count = 0;
		scope = container.getFirstChild();
		while (scope != NULL) {
			sorter[scope->toInteger(count ++)] = scope;
			scope = scope->getNext();
			}

		//  UDP ̿üϤ롣
		(*out) << "T_UDP_CCEP udp_ccep[TNUM_UDP_CCEPID] = {\n";
		count = 1;
		psorter = sorter.begin();
		while (psorter != sorter.end()) {
			(*out) << "\t{\n";

			// ITRON UDP/IP API ɸ
			(*out) << "\t\t"   << (*(*psorter).second)["cepatr"  ].toString() << ",\n";
			(*out) << "\t\t{ " << (*(*psorter).second)["myipaddr"].toString() << ", "
			                   << (*(*psorter).second)["myportno"].toString() << " },\n";
			(*out) << "\t\t"   << (*(*psorter).second)["callback"].toString() << ",\n";

			// ¸
			(*out) << "\t\tSEM_UDP_CEP_LOCK" << count    << ",\n";
			(*out) << "\t\tTA_NULL,\n";
			(*out) << "\t\tTA_NULL,\n";
			(*out) << "\t\tDTQ_UDP_RCVQ"     << count    << ",\n";
			(*out) << "\t\tDTQ_UDP_CB_RCVQ"  << count ++ << ",\n";

			(*out) << "\t\t},\n";
			psorter ++;
			}
		(*out) << "\t};\n\n";
		}
	}

//
// ConfigurationFileGenerator::outCfgTCP6_CRE_REP --  TCP/IPv6 ոϤ롣
//

void
ConfigurationFileGenerator::outCfgTCP6_CRE_REP (MultipartStream* out, Directory& container)
{
	if (container.size() > 0) {
		Directory*	scope;
		int		count;
		map<int, Directory*>		sorter;
		map<int, Directory*>::iterator	psorter;

		out->movePart(TCP6_CREATE_REP);

		// TCP/IPv6 ոϤ롣
		(*out) << "#define TNUM_TCP_CREPID\t" << container.size() << "\n\n";

		// TCP/IPv6 ոκ ID Ϥ롣
		(*out) << "const ID tmax_tcp_crepid = (TMIN_TCP_CREPID + TNUM_TCP_CREPID - 1);\n\n";

		// ID ˥Ȥ롣
		count = 0;
		scope = container.getFirstChild();
		while (scope != NULL) {
			sorter[scope->toInteger(count ++)] = scope;
			scope = scope->getNext();
			}

		//  TCP/IPv6 ոϤ롣
		(*out) << "T_TCP6_CREP tcp_crep[TNUM_TCP_CREPID] = {\n";
		count = 1;
		psorter = sorter.begin();
		while (psorter != sorter.end()) {
			(*out) << "\t{\n";

			// ITRON TCP/IP API ɸ
			(*out) << "\t\t"   << (*(*psorter).second)["repatr"  ].toString() << ",\n";
			(*out) << "\t\t{ " << (*(*psorter).second)["myipaddr"].toString() << ", "
			                   << (*(*psorter).second)["myportno"].toString() << " },\n";

			(*out) << "\t\t},\n";
			psorter ++;
			}
		(*out) << "\t};\n\n";
		}
	}

//
// ConfigurationFileGenerator::outCfgTCP6_CRE_CEP --  TCP/IPv6 ̿üϤ롣
//

void
ConfigurationFileGenerator::outCfgTCP6_CRE_CEP (MultipartStream* out, Directory& container)
{
	if (container.size() > 0) {
		Directory*	scope;
		int		count;
		map<int, Directory*>		sorter;
		map<int, Directory*>::iterator	psorter;

		out->movePart(TCP6_CREATE_CEP);

		// TCP/IPv6 ̿üϤ롣
		(*out) << "#define TNUM_TCP_CCEPID\t" << container.size() << "\n\n";

		// TCP/IPv6 ̿üκ ID Ϥ롣
		(*out) << "const ID tmax_tcp_ccepid = (TMIN_TCP_CCEPID + TNUM_TCP_CCEPID - 1);\n\n";

		// ID ˥Ȥ롣
		count = 0;
		scope = container.getFirstChild();
		while (scope != NULL) {
			sorter[scope->toInteger(count ++)] = scope;
			scope = scope->getNext();
			}

		//  TCP/IPv6 ̿üϤ롣
		(*out) << "T_TCP6_CCEP tcp_ccep[TNUM_TCP_CCEPID] = {\n";
		count = 1;
		psorter = sorter.begin();
		while (psorter != sorter.end()) {
			(*out) << "\t{\n";

			// ITRON TCP/IP API ɸ
			(*out) << "\t\t" << (*(*psorter).second)["cepatr"  ].toString() << ",\n";
			(*out) << "\t\t" << (*(*psorter).second)["sbuf"    ].toString() << ",\n";
			(*out) << "\t\t" << (*(*psorter).second)["sbufsz"  ].toString() << ",\n";
			(*out) << "\t\t" << (*(*psorter).second)["rbuf"    ].toString() << ",\n";
			(*out) << "\t\t" << (*(*psorter).second)["rbufsz"  ].toString() << ",\n";
			(*out) << "\t\t" << (*(*psorter).second)["callback"].toString() << ",\n";

			// ¸
			(*out) << "\t\tSEM_TCP_CEP_LOCK"       << count    << ",\n";
			(*out) << "\t\tSEM_TCP_CEP_SBUF_BUSY"  << count    << ",\n";
			(*out) << "\t\tSEM_TCP_CEP_RBUF_READY" << count    << ",\n";
			(*out) << "\t\tFLG_TCP_CEP"            << count ++ << ",\n";

			(*out) << "\t\t},\n";
			psorter ++;
			}
		(*out) << "\t};\n\n";
		}
	}

//
// ConfigurationFileGenerator::outCfgUDP6_CRE_CEP --  UDP/IPv6 ̿üϤ롣
//

void
ConfigurationFileGenerator::outCfgUDP6_CRE_CEP (MultipartStream* out, Directory& container)
{
	if (container.size() > 0) {
		Directory*	scope;
		int		count;
		map<int, Directory*>		sorter;
		map<int, Directory*>::iterator	psorter;

		out->movePart(UDP6_CREATE_CEP);

		// UDP/IPv6 ̿üϤ롣
		(*out) << "#define TNUM_UDP_CCEPID\t" << container.size() << "\n\n";

		// UDP/IPv6 ̿üκ ID Ϥ롣
		(*out) << "const ID tmax_udp_ccepid = (TMIN_UDP_CCEPID + TNUM_UDP_CCEPID - 1);\n\n";

		// ID ˥Ȥ롣
		count = 0;
		scope = container.getFirstChild();
		while (scope != NULL) {
			sorter[scope->toInteger(count ++)] = scope;
			scope = scope->getNext();
			}

		//  UDP/IPv6 ̿üϤ롣
		(*out) << "T_UDP6_CCEP udp_ccep[TNUM_UDP_CCEPID] = {\n";
		count = 1;
		psorter = sorter.begin();
		while (psorter != sorter.end()) {
			(*out) << "\t{\n";

			// ITRON UDP/IP API ɸ
			(*out) << "\t\t"   << (*(*psorter).second)["cepatr"  ].toString() << ",\n";
			(*out) << "\t\t{ " << (*(*psorter).second)["myipaddr"].toString() << ", "
			                   << (*(*psorter).second)["myportno"].toString() << " },\n";
			(*out) << "\t\t"   << (*(*psorter).second)["callback"].toString() << ",\n";

			// ¸
			(*out) << "\t\tSEM_UDP_CEP_LOCK" << count    << ",\n";
			(*out) << "\t\tTA_NULL,\n";
			(*out) << "\t\tTA_NULL,\n";
			(*out) << "\t\tDTQ_UDP_RCVQ"     << count    << ",\n";
			(*out) << "\t\tDTQ_UDP_CB_RCVQ"  << count ++ << ",\n";

			(*out) << "\t\t},\n";
			psorter ++;
			}
		(*out) << "\t};\n\n";
		}
	}

//
// ConfigurationFileGenerator::outCfgEMPTY_TCP_CRE_REP --  TCP ո EMPTY Ϥ롣
//

void
ConfigurationFileGenerator::outCfgEMPTY_TCP_CRE_REP (MultipartStream* out)
{
	out->movePart(TCP_CREATE_REP);

	// TCP ո0ˤϤ롣
	(*out) << "#define TNUM_TCP_CREPID\t0\n\n";

	// TCP ոκ ID Ϥ롣
	(*out) << "const ID tmax_tcp_crepid = (TMIN_TCP_CREPID + TNUM_TCP_CREPID - 1);\n\n";

	// TCP ո¤Τζ٥Ϥ롣
	(*out) << "__EMPTY_LABEL(T_TCP_CREP,tcp_crep);\n\n";
	}

//
// ConfigurationFileGenerator::outTinet_cfg_c -- TINET ե (tinet_cfg.c) Ϥ롣
//

void
ConfigurationFileGenerator::outTinet_cfg_c (Directory& container)
{
	Directory*	scope;
	TinetCfg*	out;

	out = dynamic_cast<TinetCfg *>(RuntimeObjectTable::getInstance(typeid(TinetCfg)));
	if (out == 0) {
		ExceptionMessage("Internal error: The stream buffer of tinet_cfg.c disappeared.",
		                 "顼: tinet_cfg.c ѤΥե륹ȥ꡼बޤ") << throwException;
		return;
		}

	// ɸΥ󥯥롼ɥեϤ롣
	out->movePart("header");
	if (out == 0) {
		ExceptionMessage("Internal error: The stream buffer of tinet_cfg.c disappeared.",
		                 "顼: tinet_cfg.c ѤΥե륹ȥ꡼बޤ") << throwException;
		return;
		}

	(*out) << "#include <s_services.h>\n";
	(*out) << "#include <t_services.h>\n";
	(*out) << "#include \"kernel_id.h\"\n";

	// TINET ID ե̾Ϥ롣
	(*out) << "#include \"";
	(*out) << dynamic_cast<TinetID *>(RuntimeObjectTable::getInstance(typeid(TinetID)))->getFilename();
	(*out) << "\"\n";

	//
	(*out) << "#include <tinet_defs.h>\n";
	(*out) << "#include <tinet_config.h>\n";
	(*out) << "#include <net/if.h>\n";
	(*out) << "#include <net/if_ppp.h>\n";
	(*out) << "#include <net/if_loop.h>\n";
	(*out) << "#include <net/ethernet.h>\n";
	(*out) << "#include <net/net_buf.h>\n";
	(*out) << "#include <netinet/in.h>\n";
	(*out) << "#include <netinet/ip.h>\n";
	(*out) << "#include <netinet/tcp.h>\n";
	(*out) << "#include <netinet/tcp_timer.h>\n";
	(*out) << "#include <netinet/tcp_var.h>\n";
	(*out) << "#include <netinet/tcp_fsm.h>\n";
	(*out) << "#include <netinet/udp_var.h>\n";
	(*out) << "\n";

	// 桼Υ󥯥롼ɥեϤ롣
	out->movePart(INCLUDE_FILE);
	scope = container(OBJECT_TREE "/" INCLUDE_FILE)->getFirstChild();
	while (scope != NULL) {
		(*out) << "#include " << scope->toString() << "\n";
		scope = scope->getNext();
		}
	(*out) << "\n";

	if (container[OBJECT_TREE "/" TCP_CREATE_REP].size() > 0)
		outCfgTCP_CRE_REP(out, container[OBJECT_TREE "/" TCP_CREATE_REP]);	// TCP ոϤ롣
	else if (container[OBJECT_TREE "/" TCP6_CREATE_REP].size() > 0)
		outCfgTCP6_CRE_REP(out, container[OBJECT_TREE "/" TCP6_CREATE_REP]);	// TCP/IPv6 ոϤ롣
	else
		outCfgEMPTY_TCP_CRE_REP(out);						// TCP/IP ո EMPTY Ϥ롣

	outCfgTCP_CRE_CEP(out, container[OBJECT_TREE "/" TCP_CREATE_CEP]);	// TCP ̿üϤ롣
	outCfgTCP6_CRE_CEP(out, container[OBJECT_TREE "/" TCP6_CREATE_CEP]);	// TCP/IPv6 ̿üϤ롣

	outCfgUDP_CRE_CEP(out, container[OBJECT_TREE "/" UDP_CREATE_CEP]);	// UDP ̿üϤ롣
	outCfgUDP6_CRE_CEP(out, container[OBJECT_TREE "/" UDP6_CREATE_CEP]);	// UDP/IPv6 ̿üϤ롣

	out->enableOutput();
	}

//
// ConfigurationFileGenerator::outKernCfgTCP_CRE_REP --  TCP ո˻Ѥ륫ͥ륪֥ȤϤ롣
//

void
ConfigurationFileGenerator::outKernCfgTCP_CRE_REP (MultipartStream* out, Directory& container)
{
	out->movePart(TCP_CREATE_REP);

	//  TCP ո˻Ѥ륫ͥ륪֥ȤϤ롣
	(*out) << "\n";
	}

//
// ConfigurationFileGenerator::outKernCfgTCP_CRE_CEP --  TCP ̿ü˻Ѥ륫ͥ륪֥ȤϤ롣
//

void
ConfigurationFileGenerator::outKernCfgTCP_CRE_CEP (MultipartStream* out, Directory& container)
{
	if (container.size() > 0) {
		Directory*	scope;
		int		count;

		out->movePart(TCP_CREATE_CEP);

		//  TCP ̿ü˻Ѥ륫ͥ륪֥ȤϤ롣
		count = 1;
		scope = container.getFirstChild();
		while (scope != NULL) {
			(*out) << "CRE_SEM(SEM_TCP_CEP_LOCK"       << count    << ",{ TA_TPRI, 1, 1 });\n";
			(*out) << "CRE_SEM(SEM_TCP_CEP_SBUF_BUSY"  << count    << ",{ TA_TPRI, 1, 1 });\n";
			(*out) << "CRE_SEM(SEM_TCP_CEP_RBUF_READY" << count    << ",{ TA_TPRI, 0, 1 });\n";
			(*out) << "CRE_FLG(FLG_TCP_CEP"            << count ++ << ",{ TA_TFIFO|TA_WSGL, CEP_EVT_CLOSED });\n\n";
			scope = scope->getNext();
			}
		}
	}

//
// ConfigurationFileGenerator::outKernCfgUDP_CRE_CEP --  UDP ̿ü˻Ѥ륫ͥ륪֥ȤϤ롣
//

void
ConfigurationFileGenerator::outKernCfgUDP_CRE_CEP (MultipartStream* out, Directory& container)
{
	if (container.size() > 0) {
		Directory*	scope;
		int		count;

		out->movePart(UDP_CREATE_CEP);

		//  UDP ̿ü˻Ѥ륫ͥ륪֥ȤϤ롣
		count = 1;
		scope = container.getFirstChild();
		while (scope != NULL) {
			(*out) << "CRE_SEM(SEM_UDP_CEP_LOCK" << count    << ",{ TA_TPRI, 1, 1 });\n";
			(*out) << "CRE_DTQ(DTQ_UDP_RCVQ"     << count    << ",{ TA_TFIFO, NUM_DTQ_UDP_RCVQ, NULL });\n";
			(*out) << "CRE_DTQ(DTQ_UDP_CB_RCVQ"  << count ++ << ",{ TA_TFIFO, NUM_DTQ_UDP_CB_RCVQ, NULL });\n\n";
			scope = scope->getNext();
			}
		}
	}

//
// ConfigurationFileGenerator::outKernCfgTCP6_CRE_REP --  TCP/IPv6 ո˻Ѥ륫ͥ륪֥ȤϤ롣
//

void
ConfigurationFileGenerator::outKernCfgTCP6_CRE_REP (MultipartStream* out, Directory& container)
{
	if (container.size() > 0) {
		out->movePart(TCP6_CREATE_REP);

		//  TCP/IPv6 ո˻Ѥ륫ͥ륪֥ȤϤ롣
		(*out) << "\n";
		}
	}

//
// ConfigurationFileGenerator::outKernCfgTCP6_CRE_CEP --  TCP/IPv6 ̿ü˻Ѥ륫ͥ륪֥ȤϤ롣
//

void
ConfigurationFileGenerator::outKernCfgTCP6_CRE_CEP (MultipartStream* out, Directory& container)
{
	if (container.size() > 0) {
		Directory*	scope;
		int		count;

		out->movePart(TCP6_CREATE_CEP);

		//  TCP/IPv6 ̿ü˻Ѥ륫ͥ륪֥ȤϤ롣
		count = 1;
		scope = container.getFirstChild();
		while (scope != NULL) {
			(*out) << "CRE_SEM(SEM_TCP_CEP_LOCK"       << count    << ",{ TA_TPRI, 1, 1 });\n";
			(*out) << "CRE_SEM(SEM_TCP_CEP_SBUF_BUSY"  << count    << ",{ TA_TPRI, 1, 1 });\n";
			(*out) << "CRE_SEM(SEM_TCP_CEP_RBUF_READY" << count    << ",{ TA_TPRI, 0, 1 });\n";
			(*out) << "CRE_FLG(FLG_TCP_CEP"            << count ++ << ",{ TA_TFIFO|TA_WSGL, CEP_EVT_CLOSED });\n\n";
			scope = scope->getNext();
			}
		}
	}

//
// ConfigurationFileGenerator::outKernCfgUDP6_CRE_CEP --  UDP/IPv6 ̿ü˻Ѥ륫ͥ륪֥ȤϤ롣
//

void
ConfigurationFileGenerator::outKernCfgUDP6_CRE_CEP (MultipartStream* out, Directory& container)
{
	if (container.size() > 0) {
		Directory*	scope;
		int		count;

		out->movePart(UDP6_CREATE_CEP);

		//  UDP/IPv6 ̿ü˻Ѥ륫ͥ륪֥ȤϤ롣
		count = 1;
		scope = container.getFirstChild();
		while (scope != NULL) {
			(*out) << "CRE_SEM(SEM_UDP_CEP_LOCK" << count    << ",{ TA_TPRI, 1, 1 });\n";
			(*out) << "CRE_DTQ(DTQ_UDP_RCVQ"     << count    << ",{ TA_TFIFO, NUM_DTQ_UDP_RCVQ, NULL });\n";
			(*out) << "CRE_DTQ(DTQ_UDP_CB_RCVQ"  << count ++ << ",{ TA_TFIFO, NUM_DTQ_UDP_CB_RCVQ, NULL });\n\n";
			scope = scope->getNext();
			}
		}
	}

//
// ConfigurationFileGenerator::outTinet_kern_cfg -- TINET ͥ빽ե (tinet_kern.cfg) Ϥ롣
//

void
ConfigurationFileGenerator::outTinet_kern_cfg (Directory& container)
{
	TinetKernCfg*	out;

	out = dynamic_cast<TinetKernCfg *>(RuntimeObjectTable::getInstance(typeid(TinetKernCfg)));
	if (out == 0) {
		ExceptionMessage("Internal error: The stream buffer of tinet_kern.cfg disappeared.",
		                 "顼: tinet_kern.cfg ѤΥե륹ȥ꡼बޤ") << throwException;
		return;
		}

	outKernCfgTCP_CRE_REP(out, container[OBJECT_TREE "/" TCP_CREATE_REP]);		// TCP ո˻Ѥ륫ͥ륪֥ȤϤ롣
	outKernCfgTCP_CRE_CEP(out, container[OBJECT_TREE "/" TCP_CREATE_CEP]);		// TCP ̿ü˻Ѥ륫ͥ륪֥ȤϤ롣
	outKernCfgUDP_CRE_CEP(out, container[OBJECT_TREE "/" UDP_CREATE_CEP]);		// UDP ̿ü˻Ѥ륫ͥ륪֥ȤϤ롣
	outKernCfgTCP6_CRE_REP(out, container[OBJECT_TREE "/" TCP6_CREATE_REP]);	// TCP ո˻Ѥ륫ͥ륪֥ȤϤ롣
	outKernCfgTCP6_CRE_CEP(out, container[OBJECT_TREE "/" TCP6_CREATE_CEP]);	// TCP ̿ü˻Ѥ륫ͥ륪֥ȤϤ롣
	outKernCfgUDP6_CRE_CEP(out, container[OBJECT_TREE "/" UDP6_CREATE_CEP]);	// UDP ̿ü˻Ѥ륫ͥ륪֥ȤϤ롣

	out->enableOutput();
	}

//
// ConfigurationFileGenerator::body -- ե 
//

void
ConfigurationFileGenerator::body (Directory& container)
{
	outTinet_id_h(container);	// tinet_id.h     Ϥ롣
	outTinet_cfg_c(container);	// tinet_cfg.c    Ϥ롣
	outTinet_kern_cfg(container);	// tinet_kern.cfg Ϥ롣
	}
