/*
 *  TOPPERS/JSP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Just Standard Profile Kernel
 * 
 *  Copyright (C) 2000-2004 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2001-2004 by Dep. of Computer Science and Engineering
 *                   Tomakomai National College of Technology, JAPAN
 *
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: $
 */

#ifndef _NETAPP_H_
#define _NETAPP_H_

/*
 *  äȤĹ (LONGEST) ʤ (ULONGEST)
 */

#ifdef LONGLONG_TYPE

typedef LONGLONG_TYPE		LONGEST;
typedef unsigned LONGLONG_TYPE	ULONGEST;

#else	/* of #ifdef LONGLONG_TYPE */

#ifdef LONG_TYPE

typedef LONG_TYPE		LONGEST;
typedef unsigned LONG_TYPE	ULONGEST;

#else	/* of #ifdef LONG_TYPE */

typedef int			LONGEST;
typedef unsigned int		ULONGEST;

#endif	/* of #ifdef LONG_TYPE */

#endif	/* of #ifdef LONGLONG_TYPE */

#ifdef SUPPORT_INET4

#define PUT_IPADDR(p,a,w)	put_ipv4addr(p,a,w)

#endif	/* of #ifdef SUPPORT_INET4 */

#ifdef SUPPORT_INET6

#define PUT_IPADDR(p,a,w)	put_ipv6addr(p,a,w)

#endif	/* of #ifdef SUPPORT_INET6 */

/*
 *  󥽡Ѥ륷ꥢݡֹ
 */

#ifndef CONSOLE_PORTID

#define	CONSOLE_PORTID		LOGTASK_PORTID

#endif	/* of #ifndef CONSOLE_PORTID */

/*
 *  ѴΤѴɽ
 */

extern const char radhex[];
extern const char radHEX[];

/*
 *  ؿ
 */

extern UB *skip_blanks (UB *line);
extern int cons_getline (UB *line, int size);
extern char *get_int (int *val, UB *line);
extern char *get_xuint (unsigned int *val, UB *line);
extern void cons_putchar (ID portid, char ch);
extern int cons_putnumber(ID portid, ULONGEST val, int radix,
                          const char *radchar, int width,
                          BOOL minus, char padchar);
extern void cons_printf (ID portid, const char *fmt, ...);
extern int put_macaddr (ID portid, char *mac, int width);

#ifdef SUPPORT_INET4

extern int put_ipv4addr (ID portid, ULONGEST *addr, int width);

#endif	/* of #ifdef SUPPORT_INET4 */

#ifdef SUPPORT_INET6

extern int put_ipv6addr (ID portid, const T_IN6_ADDR *addr, int width);

#endif	/* of #ifdef SUPPORT_INET6 */

#endif	/* of #ifndef _NETAPP_H_ */
