/*
 *  TOPPERS/JSP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Just Standard Profile Kernel
 * 
 *  Copyright (C) 2000-2004 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2001-2004 by Dep. of Computer Science and Engineering
 *                   Tomakomai National College of Technology, JAPAN
 *
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: $
 */

/* 
 *  TCP DISCARD 饤
 *
 *    Υ֥å󥰥
 *    IPv4
 *    IPv6
 */

#include <t_services.h>
#include "kernel_id.h"
#include "tinet_id.h"

#include <stdlib.h>

#include <netinet/in.h>
#include <netinet/in_itron.h>

#include <netapp/netapp.h>
#include <netapp/netapp_var.h>
#include <netapp/discard.h>

/*
 *  ɽ
 */

/*#define SHOW_RCV_RANGE*/

/*
 *  Хåե
 */

#define NUM_DISCARD		2
#define NUM_REP_PAT		40
#define PAT_BEGIN		' '
#define PAT_END			'~'
#define SND_BUF_SIZE		((PAT_END - PAT_BEGIN + 1) * NUM_REP_PAT)

/*
 *  ѿ
 */

BOOL tcp_discard_cli_valid;

#ifdef USE_TCP_NON_BLOCKING

/*
 *  ѿ
 */

static T_IPEP		nblk_src = {
				IP_ADDRANY,
				TCP_PORTANY,
				};
static T_IPEP		nblk_dst;
static ER_UINT		nblk_error;

/*
 *  Υ֥å󥰥ΥХåؿ
 */

ER
callback_nblk_tcp_discard_cli (ID cepid, FN fncd, VP p_parblk)
{
	static UB addr[sizeof("0123:4567:89ab:cdef:0123:4567:89ab:cdef")];

	ER	error = E_OK;

	nblk_error = (ER)p_parblk;

	switch (fncd) {

	case TFN_TCP_CON_CEP:
		IP2STR(addr, &nblk_dst.ipaddr);
		syscall(sig_sem(SEM_TCP_DISCARD_CLI_NBLK_READY));
		break;

	case TFN_TCP_CLS_CEP:
		if (nblk_error < 0)
			syslog(LOG_NOTICE, "[TDC:%02d CBN] close error: %s", cepid, itron_strerror(nblk_error));
		syscall(sig_sem(SEM_TCP_DISCARD_CLI_NBLK_READY));
		break;

	case TFN_TCP_ACP_CEP:
	case TFN_TCP_SND_DAT:
	case TFN_TCP_GET_BUF:
	case TFN_TCP_SND_OOB:
	default:
		error = E_PAR;
		break;
		}
	return error;
	}

/*
 *  send_tcp_discard -- DISCARD/TCP Ф˥å롣
 */

static void
send_tcp_discard (ID cepid, T_IN_ADDR *ipaddr, UH portno)
{
	static UB addr[sizeof("0123:4567:89ab:cdef:0123:4567:89ab:cdef")];
	static UB smsg[SND_BUF_SIZE];

	int	pat, slen, soff, discard, rep, scount, total;
	UB	*p;
	ER	error;
	SYSTIM	time;

	IP2STR(addr, ipaddr);

	nblk_dst.ipaddr = *ipaddr;
	nblk_dst.portno = portno;

	p = smsg;
	for (rep = NUM_REP_PAT; rep -- > 0; )
		for (pat = PAT_BEGIN; pat <= PAT_END; pat ++)
			*p ++ = pat;

	if ((error = TCP_CON_CEP(cepid, &nblk_src, &nblk_dst, TMO_NBLK)) != E_WBLK) {
		syslog(LOG_NOTICE, "[TDC:%02d SND] connect error: %s", cepid, itron_strerror(error));
		return;
		}

	/* ³λޤԤġ*/
	syscall(wai_sem(SEM_TCP_DISCARD_CLI_NBLK_READY));

	if (nblk_error != E_OK)
		syslog(LOG_NOTICE, "[TDC:%02d SND] connect error: %s", cepid, itron_strerror(nblk_error));
	else {
		get_tim(&time);
		syslog(LOG_NOTICE, "[TDC:%02d SND] connecting: %6d, to:   %s.%d",
		                   cepid, time / SYSTIM_HZ, addr, nblk_dst.portno);

		scount = total = 0;
		for (discard = NUM_DISCARD; discard -- > 0; ) {
			soff = 0;
			while (soff < SND_BUF_SIZE) {
				if ((slen = tcp_snd_dat(cepid, smsg + soff, sizeof(smsg) - soff, TMO_FEVR)) < 0) {
					syslog(LOG_NOTICE, "[TDC:%02d SND] send error: %s",
					                   cepid, itron_strerror(slen));
					goto cls_ret;
					}
				soff  += slen;
				total += slen;
				scount ++;

#ifdef SHOW_RCV_RANGE
				syslog(LOG_NOTICE, "[TDC:%02d SND] snd: %2d, len: %4d, off: %4d",
				                   cepid, scount, slen, soff);
#endif	/* of #ifdef SHOW_RCV_RANGE */

				dly_tsk(500 + rand() % 1000);
				}
			}

	cls_ret:
		get_tim(&time);
		syslog(LOG_NOTICE, "[TDC:%02d SND] finished:   %6d, snd: %4d,            len: %d",
		                   cepid, time / SYSTIM_HZ, scount, total);

		if ((error = tcp_sht_cep(cepid)) < 0)
			syslog(LOG_NOTICE, "[TDC:%02d SND] shutdown error: %s", cepid, itron_strerror(error));

		if ((error = tcp_cls_cep(cepid, TMO_NBLK)) != E_WBLK)
			syslog(LOG_NOTICE, "[TDC:%02d SND] close error: %s", cepid, itron_strerror(error));

		/* λޤԤġ*/
		syscall(wai_sem(SEM_TCP_DISCARD_CLI_NBLK_READY));
		}
	}

#else	/* of #ifdef USE_TCP_NON_BLOCKING */

/*
 *  send_tcp_discard -- DISCARD/TCP Ф˥å롣
 */

static void
send_tcp_discard (ID cepid, T_IN_ADDR *ipaddr, UH portno)
{
	static UB addr[sizeof("0123:4567:89ab:cdef:0123:4567:89ab:cdef")];
	static UB smsg[SND_BUF_SIZE];
	static T_IPEP src = {
		IP_ADDRANY,
		TCP_PORTANY,
		};

	T_IPEP	dst;
	int	pat, slen, soff, discard, rep, scount, total;
	UB	*p;
	ER	error;
	SYSTIM	time;

	dst.ipaddr = *ipaddr;
	dst.portno = portno;

	p = smsg;
	for (rep = NUM_REP_PAT; rep -- > 0; )
		for (pat = PAT_BEGIN; pat <= PAT_END; pat ++)
			*p ++ = pat;

	if ((error = TCP_CON_CEP(cepid, &src, &dst, 60 * 1000)) != E_OK) {
		syslog(LOG_NOTICE, "[TDC:%02d SND] connect error: %s", cepid, itron_strerror(error));
		return;
		}

	get_tim(&time);
	IP2STR(addr, ipaddr);
	syslog(LOG_NOTICE, "[TDC:%02d SND] connecting: %6d, to:   %s.%d",
	                   cepid, time / SYSTIM_HZ, &addr, portno);

	scount = total = 0;
	for (discard = NUM_DISCARD; discard -- > 0; ) {
		soff = 0;
		while (soff < SND_BUF_SIZE) {
			if ((slen = tcp_snd_dat(cepid, smsg + soff, sizeof(smsg) - soff, TMO_FEVR)) < 0) {
				syslog(LOG_NOTICE, "[TDC:%02d SND] send error: %s", cepid, itron_strerror(slen));
				goto cls_ret;
				}
			soff  += slen;
			total += slen;
			scount ++;

#ifdef SHOW_RCV_RANGE
			syslog(LOG_NOTICE, "[TDC:%02d SND] snd: %3d, len: %4d, off: %4d",
			                   cepid, scount, slen, soff);
#endif	/* of #ifdef SHOW_RCV_RANGE */

			dly_tsk(500 + rand() % 1000);
			}
		}

cls_ret:
	get_tim(&time);
	syslog(LOG_NOTICE, "[TDC:%02d SND] finished:   %6d, snd: %4d,            len: %d",
	                   cepid, time / SYSTIM_HZ, scount, total);

	if ((error = tcp_sht_cep(cepid)) < 0)
		syslog(LOG_NOTICE, "[TDC:%02d SND] shutdown error: %s", cepid, itron_strerror(error));

	if ((error = tcp_cls_cep(cepid, TMO_FEVR)) < 0)
		syslog(LOG_NOTICE, "[TDC:%02d SND] close error: %s", cepid, itron_strerror(error));
	}

#endif	/* of #ifdef USE_TCP_NON_BLOCKING */

void
tcp_discard_cli_task (VP_INT exinf)
{
	T_IN_ADDR	addr;
	UB		*line;
	UW		count;
	int		no;
	ID		tskid;
	UH		portno;

	get_tid(&tskid);
	syslog(LOG_NOTICE, "[TCP DISCARD CLI:%d,%d] started.", tskid, (ID)exinf);
	while (TRUE) {
		if (rcv_dtq(DTQ_TCP_DISCARD_CLI, (VP_INT*)(VP)&line) == E_OK) {
			line = skip_blanks(GET_IPADDR(&addr, skip_blanks(line)));
			if ('0' < *line && *line < '9') {
				line = get_int(&no, line);
				portno = (UH)no;
				}
			else {
				line ++;
				portno = 9;
				}
			line = skip_blanks(line);
			if (('0' < *line && *line < '9'))
				line = get_int(&no, line);
			else
				no = 1;
			tcp_discard_cli_valid = TRUE;
			for (count = no; count -- > 0; ) {
				if (!tcp_discard_cli_valid) {
					syslog(LOG_NOTICE, "[TDC:%02d SND] canceled.", (ID)exinf);
					break;
					}
				syslog(LOG_NOTICE, "[TDC:%02d SND] start:              repeat: %d/%d",
				                   (ID)exinf, no - count, no);
				send_tcp_discard((ID)exinf, &addr, portno);
				syslog(LOG_NOTICE, "[TDC:%02d SND] finished:           repeat: %d/%d",
				                   (ID)exinf, no - count, no);
				syscall(dly_tsk(500 + rand() % 2500));
				}
			}
		}
	}
