/*
 *  TOPPERS/JSP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Just Standard Profile Kernel
 * 
 *  Copyright (C) 2000-2004 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2001-2004 by Dep. of Computer Science and Engineering
 *                   Tomakomai National College of Technology, JAPAN
 *
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: $
 */

/* 
 *  UDP ECHO 
 */

#include <t_services.h>
#include "kernel_id.h"
#include "tinet_id.h"

#include <netinet/in.h>
#include <netinet/in_itron.h>

#include <netapp/netapp.h>
#include <netapp/netapp_var.h>
#include <netapp/echo.h>

/*
 *  ѿ
 */

#define BUF_SIZE	2048

static UB	echo_rcv_buf[BUF_SIZE];
static T_IPEP	dst;

#ifdef USE_UDP_NON_BLOCKING

#ifdef USE_UDP_CALL_BACK

#else	/* of #ifdef USE_UDP_CALL_BACK */

static int		len;

/*
 *  Υ֥å󥰥ΥХåؿ
 */

ER
callback_nblk_udp_echo_srv (ID cepid, FN fncd, VP p_parblk)
{
	static UB addr[sizeof("0123:4567:89ab:cdef:0123:4567:89ab:cdef")];

	len = (int)p_parblk;
	if (len < 0)	/* 0 ʲξϡ顼 */
		syslog(LOG_NOTICE, "[UES:%02d CBR] fncd: %s, error: %s",
		                   cepid, in_strtfn(fncd), itron_strerror(len));
	else if (fncd == TFN_UDP_RCV_DAT) {
		echo_rcv_buf[len] = '\0';
		IP2STR(addr, &dst.ipaddr);
		syslog(LOG_NOTICE, "[UES:%02d CBR] received:           from: %s.%d, len: %d, msg: '%s'",
		                   cepid, addr, dst.portno, len, echo_rcv_buf);
		}
	else if (fncd == TFN_UDP_SND_DAT)
		syslog(LOG_NOTICE, "[UES:%02d CBR] fncd: %s, len: %d", 
		                   cepid, in_strtfn(fncd), len);
	syscall(wup_tsk(UDP_ECHO_SRV_TASK));
	return E_OK;
	}

/*
 *  UDP ECHO Х
 */

void
udp_echo_srv_task(VP_INT exinf)
{
	ID	tskid;
	ER	error;

	get_tid(&tskid);
	syslog(LOG_NOTICE, "[UDP ECHO SRV (NBLK):%d,%d] started.", tskid, (ID)exinf);
	while (TRUE) {
		if ((error = UDP_RCV_DAT((ID)exinf, &dst, (VP)echo_rcv_buf, sizeof(echo_rcv_buf), TMO_NBLK)) != E_WBLK) {
			syslog(LOG_NOTICE, "[UES:%02d RCV] recv error: %s", (ID)exinf, itron_strerror(error));
			continue;
			}

		syscall(slp_tsk());
		if ((int)len > 0) {
			if ((error = UDP_SND_DAT((ID)exinf, &dst, (VP)echo_rcv_buf, len, TMO_NBLK)) != E_WBLK) {
				syslog(LOG_NOTICE, "[UES:%02d SND] send error: %s", (ID)exinf, itron_strerror(error));
				continue;
				}

			syscall(slp_tsk());
			if (len >= 0)
				syslog(LOG_NOTICE, "[UES:%02d SND] finished, len: %d", (ID)exinf, len);
			}
		}
	}

#endif	/* of #ifdef USE_UDP_CALL_BACK */

#else	/* of #ifdef USE_UDP_NON_BLOCKING */

#ifdef USE_UDP_CALL_BACK

/*
 *  Хåؿ
 */

ER
callback_udp_echo_srv (ID cepid, FN fncd, VP p_parblk)
{
	static UB addr[sizeof("0123:4567:89ab:cdef:0123:4567:89ab:cdef")];

	ER_UINT		len;

	syslog(LOG_NOTICE, "[UES:%02d UCB] fncd: %s, len: %d", cepid, in_strtfn(fncd), p_parblk);
	if ((int)(len = UDP_RCV_DAT(cepid, &dst, (VP)echo_rcv_buf, sizeof(echo_rcv_buf), TMO_FEVR)) >= 0) {
		echo_rcv_buf[len] = '\0';
		IP2STR(addr, &dst.ipaddr);
		syslog(LOG_NOTICE, "[UES:%02d UCB] received:           from: %s.%d, len: %d, msg: '%s'",
		                   cepid, addr, dst.portno, len, echo_rcv_buf);
		if ((int)len > 0) {
			if ((int)(len = UDP_SND_DAT(cepid, &dst, (VP)echo_rcv_buf, len, TMO_FEVR)) < 0)
				syslog(LOG_NOTICE, "[UES:%02d UCB] send error: %s", cepid, itron_strerror(len));
			}
		len = E_OK;
		}
	else
		syslog(LOG_NOTICE, "[UES:%02d UCB] recv error: %s", cepid, itron_strerror(len));

	return len;
	}

#else	/* of #ifdef USE_UDP_CALL_BACK */

/*
 *  UDP ECHO Х
 */

void
udp_echo_srv_task(VP_INT exinf)
{
	static UB addr[sizeof("0123:4567:89ab:cdef:0123:4567:89ab:cdef")];

	ER_UINT		len;
	ID		tskid;

	get_tid(&tskid);
	syslog(LOG_NOTICE, "[UDP ECHO SRV:%d,%d] started.", tskid, (ID)exinf);
	while (TRUE) {
		if (((int)len = UDP_RCV_DAT((ID)exinf, &dst, (VP)echo_rcv_buf, sizeof(echo_rcv_buf), TMO_FEVR)) >= 0) {
			echo_rcv_buf[len] = '\0';
			IP2STR(addr, &dst.ipaddr);
			syslog(LOG_NOTICE, "[UES:%02d RCV] received:           from: %s.%d, len: %d, msg: '%s'",
			                   (ID)exinf, addr, dst.portno, len, echo_rcv_buf);
			if ((int)len > 0) {
				if ((len = UDP_SND_DAT((ID)exinf, &dst, (VP)echo_rcv_buf, len, TMO_FEVR)) < 0)
					syslog(LOG_NOTICE, "[UES:%02d RCV] send error: %s",
					                   (ID)exinf, itron_strerror(len));
				}
			}
		else
			syslog(LOG_NOTICE, "[UES:%02d RCV] recv error: %s", (ID)exinf, itron_strerror(len));
		}
	}

#endif	/* of #ifdef USE_UDP_CALL_BACK */

#endif	/* of #ifdef USE_UDP_NON_BLOCKING */
