/*
 *  TOPPERS/JSP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Just Standard Profile Kernel
 * 
 *  Copyright (C) 2000-2004 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2001-2004 by Dep. of Computer Science and Engineering
 *                   Tomakomai National College of Technology, JAPAN
 *
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: udp_usrreq.c,v 1.2 2004/09/07 00:50:05 abe Exp abe $
 */

/*
 * Copyright (c) 1982, 1986, 1988, 1990, 1993, 1995
 *	The Regents of the University of California.  All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. All advertising materials mentioning features or use of this software
 *    must display the following acknowledgement:
 *	This product includes software developed by the University of
 *	California, Berkeley and its contributors.
 * 4. Neither the name of the University nor the names of its contributors
 *    may be used to endorse or promote products derived from this software
 *    without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 *	@(#)udp_usrreq.c	8.6 (Berkeley) 5/23/95
 * $FreeBSD: src/sys/netinet/udp_usrreq.c,v 1.49.2.2 1999/08/29 16:29:58 peter Exp $
 */

#include <string.h>

#include <s_services.h>
#include <t_services.h>
#include "kernel_id.h"

#include <tinet_defs.h>
#include <tinet_config.h>

#include <net/if.h>
#include <net/if_ppp.h>
#include <net/if_loop.h>
#include <net/ethernet.h>
#include <net/net.h>
#include <net/net_buf.h>
#include <net/net_count.h>
#include <net/ppp_ipcp.h>

#include <netinet/in.h>
#include <netinet6/in6.h>
#include <netinet/in_var.h>
#include <netinet/in_itron.h>
#include <netinet/ip.h>
#include <netinet/ip_var.h>
#include <netinet/ip_icmp.h>
#include <netinet6/in6_var.h>
#include <netinet/ip6.h>
#include <netinet6/ip6_var.h>
#include <netinet6/nd6.h>
#include <netinet/icmp6.h>
#include <netinet/udp.h>
#include <netinet/udp_var.h>

/*
 *  ؿ
 */

static ER_UINT udp_send_data (T_UDP_CCEP *cep, T_IPEP *p_dstaddr,
                              VP data, INT len, TMO tmout);
static ER udp_can_snd (T_UDP_CCEP *cep);
static ER udp_can_rcv (T_UDP_CCEP *cep);

/*
 *  udp_send_data -- ѥåμ
 */

static ER_UINT
udp_send_data (T_UDP_CCEP *cep, T_IPEP *p_dstaddr, VP data, INT len, TMO tmout)
{
	T_NET_BUF	*output;
	T_UDP_HDR	*udph;
	SYSTIM		before, after;
	ER		error = E_OK;

#ifdef UDP_CFG_OUT_CHECKSUM
	UH	sum;
#endif	/* of #ifdef UDP_CFG_OUT_CHECKSUM */

	NET_COUNT_UDP(net_count_udp.out_octets,  len);
	NET_COUNT_UDP(net_count_udp.out_packets, 1);

	/* IP ǡƤλ֤ tmout 鸺롣*/
	syscall(get_tim(&before));

	/* IP ǡƤ롣*/
	if ((error = IN_GET_DATAGRAM(&output, UDP_HDR_SIZE + len, 
	                             &p_dstaddr->ipaddr,
	                             &cep->myaddr.ipaddr,
	                             IPPROTO_UDP, IP_DEFTTL, tmout)) != E_OK)
		goto err_ret;

	/* IP ǡƤλ֤ tmout 鸺롣*/
	if (!(tmout == TMO_POL || tmout == TMO_FEVR)) {
		syscall(get_tim(&after));
		if (after - before > tmout) {
			error = E_TMOUT;
			goto err_ret;
			}
		tmout -= after - before;
		}

	/* UDP إå˾ꤹ롣*/
	udph		= GET_UDP_HDR(output);
	udph->sport	= htons(cep->myaddr.portno);
	udph->dport	= htons(p_dstaddr->portno);
	udph->ulen	= htons(UDP_HDR_SIZE + len);
	udph->sum	= 0;

	/* ǡ򥳥ԡ롣*/
	memcpy((VP)GET_UDP_SDU(output), data, len);

#ifdef UDP_CFG_OUT_CHECKSUM

	sum = IN_CKSUM(output, IPPROTO_UDP, GET_UDP_HDR_OFFSET(output), UDP_HDR_SIZE + len);

	/* ׻åͤ 0 ʤ 0xffff 롣*/
	if (sum == 0)
		sum = 0xffff;
	udph->sum = sum;

#endif	/* of #ifdef UDP_CFG_OUT_CHECKSUM */

	/* ͥåȥХåեĹĴ롣*/
	output->len = IF_IP_UDP_HDR_SIZE + len;

	/* ͥåȥ (IP) νϴؿƤӽФ*/
	if ((error = IP_OUTPUT(output, tmout)) == E_OK) {
		NET_COUNT_MIB(udp_stats.udpOutDatagrams, 1);
		cep->snd_tskid = TA_NULL;
		return len;
		}

err_ret:
	NET_COUNT_UDP(net_count_udp.out_err_packets, 1);
	cep->snd_tskid = TA_NULL;
	return error;
	}

/*
 *  udp_can_cep -- ڥǥ󥰤ƤΥ󥻥ɸൡǽ
 */

ER
udp_can_cep (ID cepid, FN fncd)
{
	T_UDP_CCEP	*cep;
	ER		error = E_OK, snd_err, rcv_err;

	/* API ǽɤå롣*/
	if (!VALID_TFN_UDP_CAN(fncd))
		return E_PAR;

	/* UDP ̿üå롣*/
	if (!VALID_UDP_CCEPID(cepid))
		return E_ID;

	/* UDP ̿ü롣*/
	cep = GET_UDP_CCEP(cepid);

	/* CEP å롣*/
	syscall(wai_sem(cep->semid_lock));

	if (fncd == TFN_UDP_ALL) {	/* TFN_TCP_ALL ν */

		snd_err = udp_can_snd(cep);
		rcv_err = udp_can_rcv(cep);

		/*
		 *  snd_err  rcv_err Τɤ EV_NOPND
		 *  ʤ顢ڥǥ󥰤ƤʤΤǥ顼
		 */
		if (snd_err == EV_NOPND && rcv_err == EV_NOPND)
			error = E_OBJ;
		else {
			if (snd_err == EV_NOPND)
				snd_err = E_OK;
			if (rcv_err == EV_NOPND)
				rcv_err = E_OK;

			if (snd_err != E_OK)
				error = snd_err;
			else if (rcv_err != E_OK)
				error = rcv_err;
			}
		}
	else if (fncd == TFN_UDP_SND_DAT) {	/* Υ󥻥 */
		if ((error = udp_can_snd(cep)) == EV_NOPND)
			error = E_OBJ;
		}
	else if (fncd == TFN_UDP_RCV_DAT) {	/* Υ󥻥 */
		if ((error = udp_can_rcv(cep)) == EV_NOPND)
			error = E_OBJ;
		}
	else
		error = E_PAR;

	/* CEP Υå롣*/
	syscall(sig_sem(cep->semid_lock));

	return error;
	}

/*
 *  udp_can_snd -- ڥǥ󥰤ƤΥ󥻥
 */

static ER
udp_can_snd (T_UDP_CCEP *cep)
{
	ER	error = E_OK;

	if (cep->snd_p_dstaddr != NULL) {	/* Υ֥å󥰥ǥڥǥ */
		if (cep->callback == NULL)
			error = E_NOEXS;
		else
			(*cep->callback)(GET_UDP_CCEPID(cep), TFN_UDP_SND_DAT, (VP)E_RLWAI);
		cep->snd_p_dstaddr = NULL;
		}
	else if (cep->snd_tskid != TA_NULL) {	/* Υ֥å󥰥ǥڥǥ */
		error = rel_wai(cep->snd_tskid);
		cep->snd_tskid = TA_NULL;
		}
	else					/* ɤǤʤʤڥǥ󥰤Ƥʤ */
		error = EV_NOPND;

	return error;
	}

/*
 *  udp_can_rcv -- ڥǥ󥰤ƤΥ󥻥
 */

static ER
udp_can_rcv (T_UDP_CCEP *cep)
{
	ER	error = E_OK;

	if (cep->rcv_p_dstaddr != NULL) {	/* Υ֥å󥰥ǥڥǥ */
		if (cep->callback == NULL)
			error = E_NOEXS;
		else
			(*cep->callback)(GET_UDP_CCEPID(cep), TFN_UDP_RCV_DAT, (VP)E_RLWAI);
		cep->rcv_p_dstaddr = NULL;
		}
	else if (cep->rcv_tskid != TA_NULL) {	/* Υ֥å󥰥ǥڥǥ */
		error = rel_wai(cep->rcv_tskid);
		cep->rcv_tskid = TA_NULL;
		}
	else					/* ɤǤʤʤڥǥ󥰤Ƥʤ */
		error = EV_NOPND;

	return error;
	}

/*
 *  udp_snd_dat -- ѥåȤɸൡǽ
 */

#ifdef SUPPORT_INET4

ER_UINT
udp_snd_dat (ID cepid, T_IPV4EP *p_dstaddr, VP data, INT len, TMO tmout)

#endif	/* of #ifdef SUPPORT_INET4 */

#ifdef SUPPORT_INET6

ER_UINT
udp6_snd_dat (ID cepid, T_IPV6EP *p_dstaddr, VP data, INT len, TMO tmout)

#endif	/* of #ifdef SUPPORT_INET6 */
{
	T_UDP_CCEP	*cep;
	ER		error;

	/* p_dstaddr ޤ data  NULL ʤ饨顼 */
	if (p_dstaddr == NULL || data == NULL)
		return E_PAR;

	/* ǡĹå롣*/
	if (len < 0 || len + IP_HDR_SIZE + UDP_HDR_SIZE > IF_MTU)
		return E_PAR;

	/* UDP ̿üå롣*/
	if (!VALID_UDP_CCEPID(cepid))
		return E_ID;

	/* UDP ̿ü롣*/
	cep = GET_UDP_CCEP(cepid);

	/*
	 * ॢȤå롣
	 */

	if (tmout == TMO_NBLK) {
		/* Υ֥å󥰥 */

		syscall(wai_sem(cep->semid_lock));
		if (cep->snd_p_dstaddr != NULL) {
			/* Υ֥å󥰥ǥڥǥ */
			error = E_QOVR;
			syscall(sig_sem(cep->semid_lock));
			}
		else if (cep->snd_tskid != TA_NULL) {
			/* Υ֥å󥰥ǥڥǥ */
			error = E_OBJ;
			syscall(sig_sem(cep->semid_lock));
			}
		else {

			cep->snd_p_dstaddr = p_dstaddr;
			cep->snd_data	= data;
			cep->snd_len	= len;
			syscall(sig_sem(cep->semid_lock));

			cep->flags |= UDP_CEP_FLG_POST_OUTPUT;
			sig_sem(SEM_UDP_POST_OUTPUT);
			error = E_WBLK;
			}
		}
	else {
		/* Υ֥å󥰥 */
	
		syscall(wai_sem(cep->semid_lock));
		if (cep->snd_p_dstaddr != NULL) {
			/* Υ֥å󥰥ǥڥǥ */
			error = E_OBJ;
			syscall(sig_sem(cep->semid_lock));
			}
		else if (cep->snd_tskid != TA_NULL) {
			/* Υ֥å󥰥ǥڥǥ */
			error = E_QOVR;
			syscall(sig_sem(cep->semid_lock));
			}
		else {

			/* ߤΥ̻ҤϿ롣*/
			get_tid(&(cep->snd_tskid));
			syscall(sig_sem(cep->semid_lock));

			/* ѥåȤ롣*/
			error = udp_send_data(cep, p_dstaddr, data, len, tmout);
			}
		}

	return error;
	}

/*
 *  udp_rcv_dat -- ѥåȤμɸൡǽ
 */

#ifdef SUPPORT_INET4

ER_UINT
udp_rcv_dat (ID cepid, T_IPV4EP *p_dstaddr, VP data, INT len, TMO tmout)

#endif	/* of #ifdef SUPPORT_INET4 */

#ifdef SUPPORT_INET6

ER_UINT
udp6_rcv_dat (ID cepid, T_IPV6EP *p_dstaddr, VP data, INT len, TMO tmout)

#endif	/* of #ifdef SUPPORT_INET6 */
{
	T_NET_BUF	*input;
	T_UDP_CCEP	*cep;
	T_UDP_HDR	*udph;
	ER_UINT		error;
	UH		ulen;

	/* p_dstaddr ޤ data  NULL len < 0 ʤ饨顼 */
	if (p_dstaddr == NULL || data == NULL || len < 0)
		return E_PAR;

	/* UDP ̿üå롣*/
	if (!VALID_UDP_CCEPID(cepid))
		return E_ID;

	/* UDP ̿ü롣*/
	cep = GET_UDP_CCEP(cepid);

	/*
	 * ॢȤå롣
	 */

	if (tmout == TMO_NBLK) {
		/* Υ֥å󥰥 */

		syscall(wai_sem(cep->semid_lock));
		if (cep->rcv_p_dstaddr != NULL)
			/* Υ֥å󥰥ǥڥǥ */
			error = E_QOVR;
		else if (cep->rcv_tskid != TA_NULL)
			/* Υ֥å󥰥ǥڥǥ */
			error = E_OBJ;
		else {
			cep->rcv_p_dstaddr = p_dstaddr;
			cep->rcv_data	= data;
			cep->rcv_len	= len;
			error = E_WBLK;
			}
		syscall(sig_sem(cep->semid_lock));
		return error;
		}
	else {
		/* Υ֥å󥰥 */

		syscall(wai_sem(cep->semid_lock));
		if (cep->rcv_p_dstaddr != NULL) {
			/* Υ֥å󥰥ǥڥǥ */
			error = E_OBJ;
			syscall(sig_sem(cep->semid_lock));
			}
		else if (cep->rcv_tskid != TA_NULL) {
			/* Υ֥å󥰥ǥڥǥ */
			error = E_QOVR;
			syscall(sig_sem(cep->semid_lock));
			}
		else {

			/* ߤΥ̻ҤϿ롣*/
			get_tid(&(cep->rcv_tskid));
			syscall(sig_sem(cep->semid_lock));

			/* ϤޤԤġ*/
			if (cep->callback != NULL) {
				if ((error = prcv_dtq(cep->cb_rcvqid, (VP_INT*)(VP)&input)) != E_OK)
					return error;
				}
			else if ((error = trcv_dtq(cep->rcvqid, (VP_INT*)(VP)&input, tmout)) != E_OK)
				return error;

			/* p_dstaddr ꤹ롣*/
			udph = GET_UDP_HDR(input);
			p_dstaddr->portno = ntohs(udph->sport);
			IN_COPY_TO_HOST(&p_dstaddr->ipaddr, &GET_IP_HDR(input)->src);

			/* ǡХåե˰ܤ*/
			ulen = ntohs(udph->ulen);
			if (ulen - UDP_HDR_SIZE > len)
				error = E_BOVR;
			else
				error = len = ulen - UDP_HDR_SIZE;

			memcpy(data, GET_UDP_SDU(input), len);

			syscall(rel_net_buf(input));

			cep->rcv_tskid = TA_NULL;
			}
		return error;
		}
	}
