/*
 *  TOPPERS/JSP Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      Just Standard Profile Kernel
 * 
 *  Copyright (C) 2000-2004 by Embedded and Real-Time Systems Laboratory
 *                              Toyohashi Univ. of Technology, JAPAN
 *  Copyright (C) 2001-2004 by Dep. of Computer Science and Engineering
 *                   Tomakomai National College of Technology, JAPAN
 *
 *  嵭Ԥϡʲ (1)(4) ξ狼Free Software Foundation 
 *  ˤäƸɽƤ GNU General Public License  Version 2 ˵
 *  ҤƤ˸¤ꡤܥեȥܥեȥ
 *  ѤΤޤࡥʲƱˤѡʣѡۡʰʲ
 *  ѤȸƤ֡ˤ뤳Ȥ̵ǵ롥
 *  (1) ܥեȥ򥽡ɤηѤˤϡ嵭
 *      ɽѾ浪Ӳ̵ݾڵ꤬Τޤޤηǥ
 *      ˴ޤޤƤ뤳ȡ
 *  (2) ܥեȥ򡤥饤֥ʤɡ¾Υեȥȯ˻
 *      ѤǤǺۤˤϡۤȼɥȡ
 *      ԥޥ˥奢ʤɡˤˡ嵭ɽѾ浪Ӳ
 *      ̵ݾڵǺܤ뤳ȡ
 *  (3) ܥեȥ򡤵Ȥ߹ʤɡ¾Υեȥȯ˻
 *      ѤǤʤǺۤˤϡΤ줫ξ
 *      ȡ
 *    (a) ۤȼɥȡѼԥޥ˥奢ʤɡˤˡ嵭
 *        ɽѾ浪Ӳ̵ݾڵǺܤ뤳ȡ
 *    (b) ۤη֤̤ˡˤäơTOPPERSץȤ
 *        𤹤뤳ȡ
 *  (4) ܥեȥѤˤľŪޤϴŪ뤤ʤ»
 *      ⡤嵭ԤTOPPERSץȤդ뤳ȡ
 *
 *  ܥեȥϡ̵ݾڤ󶡤ƤΤǤ롥嵭Ԥ
 *  TOPPERSץȤϡܥեȥ˴ؤơŬѲǽ
 *  ޤơʤݾڤԤʤޤܥեȥѤˤľ
 *  ŪޤϴŪʤ»˴ؤƤ⡤Ǥʤ
 * 
 *  @(#) $Id: udp_var.h,v 1.2 2004/09/07 00:50:05 abe Exp abe $
 */

/*
 * Copyright (c) 1982, 1986, 1989, 1993
 *	The Regents of the University of California.  All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. All advertising materials mentioning features or use of this software
 *    must display the following acknowledgement:
 *	This product includes software developed by the University of
 *	California, Berkeley and its contributors.
 * 4. Neither the name of the University nor the names of its contributors
 *    may be used to endorse or promote products derived from this software
 *    without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 *	@(#)udp_var.h	8.1 (Berkeley) 6/10/93
 * $FreeBSD: src/sys/netinet/udp_var.h,v 1.16.2.2 1999/08/29 16:29:59 peter Exp $
 */
 
#ifndef _UDP_VAR_H_
#define _UDP_VAR_H_

/*
 *  UDP إåڥɥޥ
 */

#define IP_UDP_HDR_SIZE			(IP_HDR_SIZE + UDP_HDR_SIZE)
#define IF_IP_UDP_HDR_SIZE		(IF_IP_HDR_SIZE + UDP_HDR_SIZE)

#define GET_UDP_HDR(nbuf)		((T_UDP_HDR*)((nbuf)->buf + GET_IF_IP_HDR_SIZE(nbuf)))
#define GET_UDP_SDU(nbuf)		((UB*)(nbuf)->buf + GET_IF_IP_UDP_HDR_SIZE(nbuf))

#define GET_UDP_HDR_OFFSET(nbuf)	(GET_IF_IP_HDR_SIZE(nbuf))

#define GET_IP_UDP_HDR_SIZE(nbuf)	(GET_IP_HDR_SIZE(GET_IP_HDR(nbuf)) + UDP_HDR_SIZE)
#define GET_IF_IP_UDP_HDR_SIZE(nbuf)	(GET_IP_UDP_HDR_SIZE(nbuf) + sizeof(T_IF_HDR))

/*
 *  TINET 1.1 ȤθߴΤ
 */

#ifdef SUPPORT_INET4

#define IP4_UDP_HDR_SIZE		IP_UDP_HDR_SIZE
#define IF_IP4_UDP_HDR_SIZE		IF_IP_UDP_HDR_SIZE
#define GET_IP4_UDP_HDR_SIZE(nbuf)	GET_IP_UDP_HDR_SIZE(nbuf)	
#define GET_IF_IP4_UDP_HDR_SIZE(nbuf)	GET_IF_IP_UDP_HDR_SIZE(nbuf)

#endif	/* of #ifdef SUPPORT_INET4 */

/*
 *  UDP ̿ü
 */

#ifdef SUPPORT_INET4

typedef struct t_udp_ccep {
	/* ɸ */
	ATR		cepatr;		/* UDP ̿ü°		*/
	T_IPV4EP	myaddr;		/* ʬΥɥ쥹		*/
	FP		callback;	/* Хåؿ		*/
	/* ¸ */
	ID		semid_lock;	/* ̿üå		*/
	ID		snd_tskid;	/* ̻		*/
	ID		rcv_tskid;	/* ̻		*/
	ID		rcvqid;		/* 󥳡ХåѼ塼̻*/
	ID		cb_rcvqid;	/* ХåѼ塼̻	*/
	T_IPV4EP 	*snd_p_dstaddr;	/* Υɥ쥹ؤΥݥ	*/
	VP		snd_data;	/* ǡΰƬɥ쥹	*/
	INT		snd_len;	/* ǡΰĹ		*/
	T_IPV4EP 	*rcv_p_dstaddr;	/* Υɥ쥹ؤΥݥ	*/
	VP		rcv_data;	/* ǡΰƬɥ쥹	*/
	INT		rcv_len;	/* ǡΰĹ		*/
	UH		flags;		/* ̿üե饰		*/
	} T_UDP_CCEP;

#endif	/* of #ifdef SUPPORT_INET4 */

#ifdef SUPPORT_INET6

typedef struct t_udp6_ccep {
	/* ɸ */
	ATR		cepatr;		/* UDP ̿ü°		*/
	T_IPV6EP	myaddr;		/* ʬΥɥ쥹		*/
	FP		callback;	/* Хåؿ		*/
	/* ¸ */
	ID		semid_lock;	/* ̿üå		*/
	ID		snd_tskid;	/* ̻		*/
	ID		rcv_tskid;	/* ̻		*/
	ID		rcvqid;		/* 󥳡ХåѼ塼̻*/
	ID		cb_rcvqid;	/* ХåѼ塼̻	*/
	T_IPV6EP 	*snd_p_dstaddr;	/* Υɥ쥹ؤΥݥ	*/
	VP		snd_data;	/* ǡΰƬɥ쥹	*/
	INT		snd_len;	/* ǡΰĹ		*/
	T_IPV6EP 	*rcv_p_dstaddr;	/* Υɥ쥹ؤΥݥ	*/
	VP		rcv_data;	/* ǡΰƬɥ쥹	*/
	INT		rcv_len;	/* ǡΰĹ		*/
	UH		flags;		/* ̿üե饰		*/
	} T_UDP6_CCEP;

#define T_UDP_CCEP	T_UDP6_CCEP

#endif	/* of #ifdef SUPPORT_INET6 */

/*
 *  UDP ̿üե饰
 */

#define UDP_CEP_FLG_POST_OUTPUT	0x0200	/* 򳫻Ϥ롣		*/

/*
 *  ֥ ID κǾͤ
 */

#define	TMIN_UDP_CCEPID		1	/* UDP ̿ü ID κǾ */

#ifdef SUPPORT_MIB

/*
 *  SNMP  ١ (MIB)
 */

typedef struct t_udp_stats {
	UW	udpInDatagrams;
	UW	udpNoPorts;
	UW	udpInErrors;
	UW	udpOutDatagrams;
} T_UDP_STATS;

#endif	/* of #ifdef SUPPORT_MIB */

/*
 *  ؿߥ졼ޥ
 */

#define VALID_UDP_CCEPID(id)	(TMIN_UDP_CCEPID<=(id)&&(id)<=tmax_udp_ccepid)

#define INDEX_UDP_CCEP(id)	((id)-TMIN_UDP_CCEPID)

#define GET_UDP_CCEP(id)	(&(udp_ccep[INDEX_UDP_CCEP(id)]))

#define GET_UDP_CCEPID(cep)	(((cep)-udp_ccep)+TMIN_UDP_CCEPID)

#define VALID_TFN_UDP_CAN(t)	((t)==TFN_UDP_SND_DAT||(t)==TFN_UDP_RCV_DAT||\
				 (t)==TFN_UDP_ALL)

/*
 *  ѿ
 */

extern T_UDP_CCEP udp_ccep[];
extern const ID tmax_udp_ccepid;

#ifdef SUPPORT_MIB

extern T_UDP_STATS udp_stats;

#endif	/* of #ifdef SUPPORT_MIB */

/*
 *  ؿ
 */

extern int udp_input (T_NET_BUF *input, int *offp);

/* Υ֥å󥰥ԤȤ߹ॿ */

extern void	udp_output_task(VP_INT exinf);

#endif	/* of #ifndef _UDP_VAR_H_ */
